## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# Generated by rust2rpm 27
%bcond check 1
%global debug_package %{nil}

%global crate prost-reflect

Name:           rust-prost-reflect
Version:        0.14.7
Release:        %autorelease
Summary:        Protobuf library extending prost with reflection support and dynamic messages

License:        MIT OR Apache-2.0
URL:            https://crates.io/crates/prost-reflect
Source:         %{crates_source}
Source2:        https://raw.githubusercontent.com/andrewhickman/prost-reflect/refs/tags/0.14.6/LICENSE-APACHE
Source3:        https://raw.githubusercontent.com/andrewhickman/prost-reflect/refs/tags/0.14.6/LICENSE-MIT

BuildRequires:  cargo-rpm-macros >= 24
BuildRequires:  tomcli

%global _description %{expand:
A protobuf library extending prost with reflection support and dynamic
messages.}

%description %{_description}

%package        devel
Summary:        %{summary}
BuildArch:      noarch

%description    devel %{_description}

This package contains library source intended for building other packages which
use the "%{crate}" crate.

%files          devel
%license %{crate_instdir}/LICENSE-APACHE
%license %{crate_instdir}/LICENSE-MIT
%doc %{crate_instdir}/README.md
%{crate_instdir}/

%package     -n %{name}+default-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+default-devel %{_description}

This package contains library source intended for building other packages which
use the "default" feature of the "%{crate}" crate.

%files       -n %{name}+default-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+base64-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+base64-devel %{_description}

This package contains library source intended for building other packages which
use the "base64" feature of the "%{crate}" crate.

%files       -n %{name}+base64-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+derive-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+derive-devel %{_description}

This package contains library source intended for building other packages which
use the "derive" feature of the "%{crate}" crate.

%files       -n %{name}+derive-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+logos-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+logos-devel %{_description}

This package contains library source intended for building other packages which
use the "logos" feature of the "%{crate}" crate.

%files       -n %{name}+logos-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+miette-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+miette-devel %{_description}

This package contains library source intended for building other packages which
use the "miette" feature of the "%{crate}" crate.

%files       -n %{name}+miette-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+prost-reflect-derive-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+prost-reflect-derive-devel %{_description}

This package contains library source intended for building other packages which
use the "prost-reflect-derive" feature of the "%{crate}" crate.

%files       -n %{name}+prost-reflect-derive-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+serde-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+serde-devel %{_description}

This package contains library source intended for building other packages which
use the "serde" feature of the "%{crate}" crate.

%files       -n %{name}+serde-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+serde-value-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+serde-value-devel %{_description}

This package contains library source intended for building other packages which
use the "serde-value" feature of the "%{crate}" crate.

%files       -n %{name}+serde-value-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+serde1-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+serde1-devel %{_description}

This package contains library source intended for building other packages which
use the "serde1" feature of the "%{crate}" crate.

%files       -n %{name}+serde1-devel
%ghost %{crate_instdir}/Cargo.toml

%package     -n %{name}+text-format-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+text-format-devel %{_description}

This package contains library source intended for building other packages which
use the "text-format" feature of the "%{crate}" crate.

%files       -n %{name}+text-format-devel
%ghost %{crate_instdir}/Cargo.toml

%prep
%autosetup -n %{crate}-%{version} -p1
%cargo_prep
cp %{SOURCE2} .
cp %{SOURCE3} .
# Avoid circular dependency with protox
# https://github.com/andrewhickman/prost-reflect/issues/154
tomcli set Cargo.toml del dev-dependencies.protox
# Disable test that use protox
sed -r -i 's/(fn compare_parsed_and_coded_default_descriptors.*)/#[cfg(any())]\n\1/' src/reflect/wkt.rs
sed -r -i 's/(fn expected_well_known_types.*)/#[cfg(any())]\n\1/' src/reflect/wkt.rs
# Broken test because tests.rs is not in crate
sed -i '/#\[cfg(test)\]/,/mod tests/d' src/descriptor/mod.rs

%generate_buildrequires
%cargo_generate_buildrequires

%build
%cargo_build

%install
%cargo_install

%if %{with check}
%check
# * - Almost all tests are skipped because they require file_descriptor_set.bin
#   which is not included.
# * - dynamic::type_sizes This test uses std::mem::size_of which is inconsistent
#   on i686
%{cargo_test -- -- %{shrink:
    --skip dynamic::DynamicMessage::decode
    --skip dynamic::DynamicMessage::fmt
    --skip dynamic::DynamicMessage::has_field
    --skip dynamic::DynamicMessage::try_set_field
    --skip dynamic::DynamicMessage::try_set_field_by_name
    --skip dynamic::DynamicMessage::try_set_field_by_number
    --skip dynamic::unknown::UnknownField::decode
    --skip dynamic::unknown::UnknownField::decode_value
    --skip dynamic::unknown::UnknownField::fmt
    --skip src/lib.rs
    --skip dynamic::type_sizes
}}
%endif

%changelog
## START: Generated by rpmautospec
* Thu Apr 10 2025 John Doe <packager@example.com> - 0.14.7-1
- Uncommitted changes
## END: Generated by rpmautospec
